=== debian/changelog ===
rr (5.6.0-4ubuntu0.1) mantic; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.6.0-4) unstable; urgency=medium

  * Apply upstream patch to add missing cstdint includes, allowing
    building with GCC 13. Closes: #1037848.
  * Standards-Version 4.6.2, no change required.
  * Pass C flags to the assembler, to avoid storing absolute paths in
    files produced by the assembler. Thanks to Bernhard Übelacker for
    the patch! Closes: #973894.

 -- Stephen Kitt <skitt@debian.org>  Sun, 25 Jun 2023 18:10:44 +0200

rr (5.6.0-3) unstable; urgency=medium

  * Apply upstream patch to avoid building a struct embedding a flexible-
    length array from ethtool_sset_info. Closes: #1022316.
  * Update debian/copyright to cover proc_service.h.

 -- Stephen Kitt <skitt@debian.org>  Sun, 23 Oct 2022 17:25:02 +0200

rr (5.6.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Aug 2022 18:01:09 +0200

rr (5.6.0-2~exp1) experimental; urgency=medium

  * Enable building on arm64.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Aug 2022 10:49:43 +0200

rr (5.6.0-1) unstable; urgency=medium

  [ Stephen Kitt ]
  * New upstream release.
  * Update lintian overrides for lintian 2.115.0.
  * Standards-Version 4.6.1, no further change required.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.

 -- Stephen Kitt <skitt@debian.org>  Sun, 14 Aug 2022 14:53:38 +0200
