=== debian/control ===
Source: rr
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: capnproto,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               g++-multilib [amd64],
               gdb,
               libcapnp-dev,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python3,
               python3-pexpect,
               zlib1g-dev,
# The following are required for the test suite
# realpath
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/rr
Vcs-Git: https://salsa.debian.org/debian/rr.git
Homepage: https://rr-project.org
Rules-Requires-Root: no

Package: rr
Architecture: amd64 arm64 i386
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         sse2-support [i386]
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel CPUs with Nehalem or later microarchitectures, some AMD CPUs
 with Zen or later microarchitectures, and some AArch64
 microarchitectures (e.g. ARM Neoverse N1 or Apple Silicon M-series).
 The amd64 package supports debugging amd64 and i386 binaries.
