## rr 5.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # *-* Mode: cmake; *-*
 
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.5)
 project(rr C CXX ASM)
 
 # "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
@@ -34,8 +34,12 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 6)
+set(rr_VERSION_MINOR 7)
 set(rr_VERSION_PATCH 0)
+
+if(ANDROID)
+  find_package(CapnProto REQUIRED)
+endif()
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
@@ -48,6 +52,10 @@
 configure_file(
   ${CMAKE_SOURCE_DIR}/src/git_revision.h.in
   ${CMAKE_BINARY_DIR}/git_revision.h
+)
+configure_file(
+  ${CMAKE_SOURCE_DIR}/src/extra_version_string.h.in
+  ${CMAKE_BINARY_DIR}/extra_version_string.h
 )
 
 set(FLAGS_COMMON "-D__USE_LARGEFILE64 -pthread")
@@ -78,13 +86,7 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++14" SUPPORTS_CXX14)
-if (SUPPORTS_CXX14)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
-else()
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
-endif()
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -97,7 +99,7 @@
 set(RR_FLAGS_DEBUG "-Wall -Wextra -DDEBUG -UNDEBUG")
 set(RR_FLAGS_RELEASE "-Wall -Wextra -UDEBUG -DNDEBUG")
 
-# The folowing settings are the defaults for the OTHER build type.
+# The following settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
 set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
@@ -132,7 +134,11 @@
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 endif()
-if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang")
+# -fno-integrated-as tells Clang to use whatever "as" happens to be. For an
+# Android build that will end up being whatever /usr/bin/as is, and whatever it
+# is, it's the wrong assembler for Android, because Android only supports the
+# Clang assembler.
+if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang" AND NOT ANDROID)
   set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
 
@@ -229,7 +235,12 @@
 
 # ==== brotli ====
 set(BROTLI_FILES
+  third-party/brotli/common/constants.c
+  third-party/brotli/common/context.c
   third-party/brotli/common/dictionary.c
+  third-party/brotli/common/platform.c
+  third-party/brotli/common/shared_dictionary_internal.h
+  third-party/brotli/common/shared_dictionary.c
   third-party/brotli/common/transform.c
   third-party/brotli/dec/bit_reader.c
   third-party/brotli/dec/decode.c
@@ -249,15 +260,17 @@
   third-party/brotli/enc/block_splitter_inc.h
   third-party/brotli/enc/brotli_bit_stream.c
   third-party/brotli/enc/brotli_bit_stream.h
+  third-party/brotli/enc/command.c
   third-party/brotli/enc/cluster.c
   third-party/brotli/enc/cluster.h
   third-party/brotli/enc/cluster_inc.h
   third-party/brotli/enc/command.h
   third-party/brotli/enc/compress_fragment.c
   third-party/brotli/enc/compress_fragment.h
+  third-party/brotli/enc/compound_dictionary.c
+  third-party/brotli/enc/compound_dictionary.h
   third-party/brotli/enc/compress_fragment_two_pass.c
   third-party/brotli/enc/compress_fragment_two_pass.h
-  third-party/brotli/enc/context.h
   third-party/brotli/enc/dictionary_hash.c
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
@@ -265,6 +278,7 @@
   third-party/brotli/enc/entropy_encode.c
   third-party/brotli/enc/entropy_encode.h
   third-party/brotli/enc/entropy_encode_static.h
+  third-party/brotli/enc/fast_log.c
   third-party/brotli/enc/fast_log.h
   third-party/brotli/enc/find_match_length.h
   third-party/brotli/enc/hash_forgetful_chain_inc.h
@@ -283,28 +297,10 @@
   third-party/brotli/enc/metablock.c
   third-party/brotli/enc/metablock.h
   third-party/brotli/enc/metablock_inc.h
-  third-party/brotli/enc/port.h
   third-party/brotli/enc/prefix.h
   third-party/brotli/enc/quality.h
   third-party/brotli/enc/ringbuffer.h
+  third-party/brotli/enc/state.h
   third-party/brotli/enc/static_dict.c
   third-party/brotli/enc/static_dict.h
   third-party/brotli/enc/static_dict_lut.h
-  third-party/brotli/enc/utf8_util.c
-  third-party/brotli/enc/utf8_util.h
-  third-party/brotli/enc/write_bits.h
-)
-add_library(brotli STATIC ${BROTLI_FILES})
-set_source_files_properties(${BROTLI_FILES}
-                            PROPERTIES COMPILE_FLAGS ${BROTLI_COMPILE_FLAGS})
-# ==== brotli ====
-
-find_library(LIBRT rt)
-
-find_path(SECCOMP NAMES "linux/seccomp.h")
-if(NOT SECCOMP)
-  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
-endif()
-
-find_path(EXECINFO_H NAMES "execinfo.h")
-if(EXECINFO_H)
