=== debian/changelog ===
rr (5.7.0-2ubuntu0.24.04.1) noble; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.7.0-2build1) noble; urgency=medium

  * Rebuild against new libcapnp-1.0.1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2023 12:31:29 +0200

rr (5.7.0-2) unstable; urgency=medium

  * Build with Debian’s brotli package.
  * Add test setup to account for the moved stubs.
  * Drop obsolete Lintian spelling overrides.
  * Use C.UTF-8 for tests on Debian, it’s always available, unlike
    en_US.UTF-8.

 -- Stephen Kitt <skitt@debian.org>  Mon, 16 Oct 2023 21:27:45 +0200

rr (5.7.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 07 Oct 2023 20:53:52 +0200
