=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                dh-python,
                g++-multilib [amd64],
                gdb,
+               libbrotli-dev,
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,
