## rr 5.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,12 @@
   cmake_policy(SET CMP0065 NEW)
 endif()
 
+# We should switch to using FindPython3, but that requires CMake 3.12.
+# We'll switch later.
+if(POLICY CMP0148)
+  cmake_policy(SET CMP0148 OLD)
+endif()
+
 # On single configuration generators, make Debug the default configuration
 if(NOT CMAKE_CONFIGURATION_TYPES)
   if(NOT CMAKE_BUILD_TYPE)
@@ -34,7 +40,7 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 7)
+set(rr_VERSION_MINOR 8)
 set(rr_VERSION_PATCH 0)
 
 if(ANDROID)
@@ -68,12 +74,14 @@
   set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a -moutline-atomics")
   set(PRELOAD_LIBRARY_PAGE_SIZE 65536)
   set(VDSO_NAME "LINUX_2.6.39")
+  set(VDSO_SYMBOLS "__kernel_clock_getres; __kernel_rt_sigreturn; __kernel_gettimeofday; __kernel_clock_gettime;")
 else()
   set(x86ish true)
   set(has_syscallbuf true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
   set(PRELOAD_LIBRARY_PAGE_SIZE 4096)
   set(VDSO_NAME "LINUX_2.6")
+  set(VDSO_SYMBOLS "__vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
 endif()
 configure_file(src/preload/rr_page.ld.in src/preload/rr_page.ld @ONLY)
 
@@ -293,14 +301,3 @@
   third-party/brotli/enc/literal_cost.c
   third-party/brotli/enc/literal_cost.h
   third-party/brotli/enc/memory.c
-  third-party/brotli/enc/memory.h
-  third-party/brotli/enc/metablock.c
-  third-party/brotli/enc/metablock.h
-  third-party/brotli/enc/metablock_inc.h
-  third-party/brotli/enc/prefix.h
-  third-party/brotli/enc/quality.h
-  third-party/brotli/enc/ringbuffer.h
-  third-party/brotli/enc/state.h
-  third-party/brotli/enc/static_dict.c
-  third-party/brotli/enc/static_dict.h
-  third-party/brotli/enc/static_dict_lut.h
