=== debian/changelog ===
rr (5.8.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1071515.
  * Build-depend on pkgconf instead of pkg-config.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 20 May 2024 17:35:13 +0200
