=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: rr
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: capnproto,
@@ -13,13 +12,13 @@
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,
-               pkg-config,
+               pkgconf,
                python3,
                python3-pexpect,
                zlib1g-dev,
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: https://rr-project.org
