## rr 5.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,15 @@
   endif()
 endif()
 
+option(INSTALL_TESTSUITE "Install the testsuite")
+option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
+option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")
+option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")
+option(bpf "Enable bpf acceleration")
+option(asan "Build with address sanitizer enabled.")
+option(intel_pt_decoding "Build with Intel PT decoding enabled.")
+option(strip "Strip debug info from rr binary")
+
 enable_testing()
 set(BUILD_SHARED_LIBS ON)
 
@@ -34,13 +43,12 @@
 
 set(BUILD_TESTS ON CACHE BOOL "Build tests")
 set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
-option(INSTALL_TESTSUITE "Install the testsuite")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 8)
+set(rr_VERSION_MINOR 9)
 set(rr_VERSION_PATCH 0)
 
 if(ANDROID)
@@ -75,13 +83,15 @@
   set(PRELOAD_LIBRARY_PAGE_SIZE 65536)
   set(VDSO_NAME "LINUX_2.6.39")
   set(VDSO_SYMBOLS "__kernel_clock_getres; __kernel_rt_sigreturn; __kernel_gettimeofday; __kernel_clock_gettime;")
-else()
+elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES i386|i686|x86|x86_64)
   set(x86ish true)
   set(has_syscallbuf true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
   set(PRELOAD_LIBRARY_PAGE_SIZE 4096)
   set(VDSO_NAME "LINUX_2.6")
-  set(VDSO_SYMBOLS "__vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
+  set(VDSO_SYMBOLS "gettimeofday; clock_gettime; __vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
+else()
+  message(FATAL_ERROR "The architecture " ${CMAKE_SYSTEM_PROCESSOR} " is not yet supported")
 endif()
 configure_file(src/preload/rr_page.ld.in src/preload/rr_page.ld @ONLY)
 
@@ -94,7 +104,7 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++17")
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -109,7 +119,9 @@
 
 # The following settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
-set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
+# LTO breaks us by moving code around.
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE -fno-lto")
+set(PRELOAD_LINK_FLAGS "-nostartfiles -fno-lto")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
 set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
 # Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
@@ -149,9 +161,6 @@
 if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang" AND NOT ANDROID)
   set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
-
-option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
-option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")
 
 if(force32bit)
   set(rr_32BIT true)
@@ -171,8 +180,6 @@
   endif()
   set(rr_MBITNESS_OPTION)
 endif()
-
-option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")
 
 # Check that compiling 32-bit code on a 64-bit target works, if required.
 if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND rr_32BIT)
@@ -224,6 +231,24 @@
 # zlib is required to handle ELF compression
   zlib
 )
+
+if(NOT ANDROID)
+  set(REQUIRED_LIBS
+    ${REQUIRED_LIBS}
+    # zstd is required to handle ELF compression, but isn't available on Android.
+    libzstd
+  )
+  set(ZSTD 1)
+  add_definitions(-DZSTD=1)
+endif()
+
+if(bpf)
+  add_definitions(-DBPF=1)
+  set(REQUIRED_LIBS
+    ${REQUIRED_LIBS}
+    libbpf
+  )
+endif(bpf)
 
 foreach(required_lib ${REQUIRED_LIBS})
   string(TOUPPER ${required_lib} PKG)
@@ -283,21 +308,3 @@
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
   third-party/brotli/enc/encoder_dict.c
-  third-party/brotli/enc/entropy_encode.c
-  third-party/brotli/enc/entropy_encode.h
-  third-party/brotli/enc/entropy_encode_static.h
-  third-party/brotli/enc/fast_log.c
-  third-party/brotli/enc/fast_log.h
-  third-party/brotli/enc/find_match_length.h
-  third-party/brotli/enc/hash_forgetful_chain_inc.h
-  third-party/brotli/enc/hash.h
-  third-party/brotli/enc/hash_longest_match64_inc.h
-  third-party/brotli/enc/hash_longest_match_inc.h
-  third-party/brotli/enc/hash_longest_match_quickly_inc.h
-  third-party/brotli/enc/hash_to_binary_tree_inc.h
-  third-party/brotli/enc/histogram.c
-  third-party/brotli/enc/histogram.h
-  third-party/brotli/enc/histogram_inc.h
-  third-party/brotli/enc/literal_cost.c
-  third-party/brotli/enc/literal_cost.h
-  third-party/brotli/enc/memory.c
