=== debian/changelog ===
rr (5.9.0-6) unstable; urgency=medium

  * Install the rr helper binaries in /usr/libexec/rr instead of
    /usr/lib/rr.
  * Fix zsh completions permissions.
  * Avoid redefining struct open_how. Closes: #1128848.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 23 Feb 2026 19:29:55 +0100

rr (5.9.0-5) unstable; urgency=medium

  * Add another upstream patch required to build without termio.

 -- Stephen Kitt <skitt@debian.org>  Sat, 06 Dec 2025 18:13:36 +0100

rr (5.9.0-4) unstable; urgency=medium

  * Provide a definition of termio to allow building with glibc 2.42,
    which dropped it. Closes: #1115210.
  * Remove the old FSF address from debian/copyright.
  * Drop “Rules-Requires-Root: no” since it’s now the default.

 -- Stephen Kitt <skitt@debian.org>  Sat, 06 Dec 2025 09:47:45 +0100

rr (5.9.0-3) unstable; urgency=medium

  * Disable BPF, it’s not ready for general consumption; see
    https://github.com/rr-debugger/rr/issues/3938 for details.

 -- Stephen Kitt <skitt@debian.org>  Wed, 26 Mar 2025 20:11:56 +0100

rr (5.9.0-2) unstable; urgency=medium

  * Only enable BPF on amd64, it fails to build on other architectures.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Mar 2025 23:09:35 +0100

rr (5.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Enable BPF support.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Mar 2025 15:10:40 +0100

rr (5.8.0-2) unstable; urgency=medium

  * Disable pointer authentication to avoid crashing in initialization
    code on pre-v8.3-A CPUs. Thanks to Emanuele Rocca for the tip!
    Closes: #1078916.

 -- Stephen Kitt <skitt@debian.org>  Wed, 21 Aug 2024 09:09:43 +0200
