=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: rr
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
-Priority: optional
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 13),
@@ -12,17 +11,18 @@
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,
+               libzstd-dev,
+               lldb,
                pkgconf,
                python3,
                python3-pexpect,
                zlib1g-dev,
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: https://rr-project.org
-Rules-Requires-Root: no
 
 Package: rr
 Architecture: amd64 arm64 i386
