=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-branch
 
 export DH_OPTIONS += -O-Bbuild
 
@@ -25,11 +25,11 @@
 	dh_auto_install
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
-	mkdir -p debian/rr/usr/lib/rr
-	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
+	mkdir -p debian/rr/usr/lib/rr debian/rr/usr/libexec/rr
+	mv debian/rr/usr/bin/rr_* debian/rr/usr/libexec/rr/
 	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/lib*.so debian/rr/usr/lib/rr/
 	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
-	chmod 644 debian/rr/usr/share/bash-completion/completions/rr
+	chmod 644 debian/rr/usr/share/bash-completion/completions/rr debian/rr/usr/share/zsh/site-functions/_rr
 
 override_dh_strip:
 	dh_strip -Xlibrr
